100 REMark Administrator program for controlling user logins and passwords
110 REMark for Launchpad, written by Dilwyn Jones 2002
120 :
130 REMark set equivalent of WTV 4 sized windows
140 WINDOW #0,448,40,32,216
150 WINDOW #1,448,200,32,16
160 WINDOW #2,448,200,32,16
170 CLS : CLS #0
180 :
190 PRINT #0,'I need to load a file called LAUNCHPAD_pwl.'
200 INPUT #0,'Enter name of drive/directory holding this file > ';ip$
210 IF ip$ = '' THEN STOP
220 :
230 REMark read in the contents of the user names/passwords file
240 OPEN_IN #3,ip$&'LAUNCHPAD_pwl'
250 chk$ = '' : REMark is this a Launchpad PassWords List?
260 FOR a = 0 TO 3 : chk$ = chk$ & INKEY$(#3)
270 IF NOT(chk$='PWL1') THEN CLOSE #3 : PRINT #0,'Invalid file' : STOP
280 :
290 GET #3,no_of_users% : REMark 1-16, how many users defined
300 :
310 REMark the user_id% array holds the user ID number used internally
320 REMark to identify which LAUNCHPADx_DAT file is used for this user
330 REMark CHANGE THIS AT YOUR PERIL...LAUNCHPAD MAY NOT FORGIVE YOU!!!
340 DIM user_id% (15)
350 :
360 REMark User Names, each up to 16 characters long
370 REMark User 0 may have a blank User Name, with or without password
380 DIM username$(15,16) : REMark User Names (up to 16 characters)
390 DIM password$(15,16) : REMark Passwords  (stored encoded)
400 FOR a = 0 TO no_of_users%-1
410   GET #3,user_id%(a)
420   GET #3,username$(a)
430   GET #3,password$(a) : password$(a) = Encode$(password$(a))
440 END FOR a
450 CLOSE #3
460 :
470 REMark if any changes are made, the file needs to be saved
480 changes% = 0 : REMark if any changes made, value becomes 1
490 :
500 REPeat alter_details
510   CLS : PRINT'#' TO 4;'USER ID' TO 12;'USER NAME' TO 30;'PASSWORD'
520   FOR a = 0 TO no_of_users%-1
530     AT a+1,0
540     PRINT a+1 TO 4;user_id%(a) TO 12;username$(a) TO 30;password$(a)
550   END FOR a
560   CLS #0
570   PRINT#0,'Enter # number of user details to change (0 to finish) > ';
580   INPUT #0,h$
590   IF h$ = '0' OR h$ = '' THEN EXIT alter_details
600   hash = '0'&h$
610   IF hash < 1 OR hash > no_of_users% OR hash <> INT(hash) THEN
620     PRINT #0,'Out of range!' : PAUSE 100 : NEXT alter_details
630   END IF
640   CLS #0 : hash = hash-1 : REMark user 0-15
650   REPeat get_entry
660     INPUT #0,'Enter new username for ';(username$(hash));' > ';usr$
670     :
680     REMark user 0 (always first in list) may have no name
690     IF hash = 0 AND usr$ = '' THEN EXIT get_entry
700     :
710     REMark what else can go wrong ?!?!?
720     IF hash > 0 AND usr$ = '' THEN
730       REMark Apart from User 0, all other users must have a User Name
740       BEEP 5000,50 : PRINT #0,'This user must have a user name!'
750       NEXT get_entry
760     END IF
770     :
780     REMark name must be no more than 16 characters long
790     IF LEN(usr$) > 16 THEN
800       BEEP 5000,50 : PRINT #0,'Entry too long!' : NEXT get_entry
810     END IF
820     :
830     REMark probably OK by now!
840     EXIT get_entry
850   END REPeat get_entry
860   :
870   REMark specify new password (or none!)
880   REPeat get_entry
890     INPUT #0,'Enter new password for this user > ';pas$
900     IF LEN(pas$) > 16 THEN
910       BEEP 5000,50 : PRINT #0,'Too long!'
920       NEXT get_entry
930     END IF
940     EXIT get_entry
950   END REPeat get_entry
960   :
970   REMark we have the new details, update the list
980   username$(hash) = usr$ : REMark altered user name
990   password$(hash) = pas$ : REMark altered password
1000   changes% = 1 : REMark changes made which will need ot be saved
1010 END REPeat alter_details
1020 :
1030 IF changes% = 0 THEN
1040   PRINT #0,'No changes made, program finished.'
1050   STOP
1060 END IF
1070 :
1080 REMark need to save the altered details
1090 CLS #0
1100 INPUT #0,'Save LAUNCHPAD_pwl to drive/directory > ';op$
1110 IF op$ = '' THEN STOP
1120 :
1130 DELETE op$&'LAUNCHPAD_pwl'
1140 OPEN_NEW #3,op$&'LAUNCHPAD_pwl'
1150 :
1160 REMark send file identifier
1170 PRINT #3,'PWL1';
1180 :
1190 REMark send number of users saved in this file
1200 PUT #3,no_of_users%
1210 :
1220 REMark send the user names and passwords
1230 FOR a = 0 TO no_of_users%-1
1240   PUT #3,user_id% (a)          : REMark internal user ID number
1250   PUT #3,username$(a)          : REMark user name
1260   PUT #3,Encode$(password$(a)) : REMark encoded password
1270 END FOR a
1280 :
1290 REMark strictly speaking, no closing LF is needed, but makes it
1300 REMark easier for editors and BASIC programs to handle the
1310 REMark LAUNCHPAD_pwl file if required, preventing End Of File errors
1320 BPUT #3,10 : REMark allows file to be inspected with some editors
1330 :
1340 CLOSE #3 : REMark finished!
1350 PRINT #0,'Passwords file updated, program finished.'
1360 STOP
1370 :
1380 DEFine FuNction Encode$(st$)
1390   LOCal t$,a
1400   t$ = st$
1410   FOR a = 1 TO LEN(t$)
1420     t$(a) = CHR$(255-CODE(st$(a)))
1430   END FOR a
1440   RETurn t$
1450 END DEFine Encode$
